package pl.edu.s3996.zad5;

import javax.naming.Context;
import javax.naming.InitialContext;
import javax.naming.NamingException;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.sql.DataSource;
import java.io.IOException;
import java.io.PrintWriter;
import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.Statement;

/**
 * Created by Adam on 2014-06-03.
 */
public class ServletEdit extends HttpServlet {

    private DataSource dataSource;

    public void init() throws ServletException {
        try {
            Context init = new InitialContext();
            Context contx = (Context) init.lookup("java:comp/env");
            dataSource = (DataSource) contx.lookup("jdbc/usersdb");
        } catch (NamingException exc) {
            throw new ServletException(
                    "Nie mogę uzyskać źródła java:comp/env/jdbc/usersdb", exc);
        }
    }



    protected void doPost(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
        response.setContentType("text/html; charset=windows-1250");
        PrintWriter out = response.getWriter();
        Connection con = null;

        try {

            String username = request.getParameter("username");
            String password = request.getParameter("password");
            if (username == null ||  password == null  || username == "" || password == "")
            {
                out.println("Pola Nazwa oraz Hasło są wymagane!");
                return;
            }


            synchronized (dataSource) {
                con = dataSource.getConnection();
            }
            String idParam = request.getParameter("id");

            if (idParam == null ||  idParam == "")
            {
                out.println("Nie podano identyfikatora użytkownika do edycji ");
                return;
            }

            int id;
            try
            {
                id = Integer.parseInt(idParam);
            }
            catch (NumberFormatException e)
            {
                out.println("Parametr ID powinien być liczbą całkowitą!");
                return;
            }

            Statement stmt = con.createStatement();

            ResultSet rs = stmt.executeQuery("select * from users WHERE user_id = "+ idParam);

            if (!rs.next()) {
                out.println("Nie znaleziono wskazanego użytkownika");
                return;
            }
            String name = request.getParameter("username");
            String pass = request.getParameter("password");

            PreparedStatement statement = con.prepareStatement("UPDATE users SET user_name = ?, user_password = ? WHERE user_id = ?");
            statement.setString(1,name);
            statement.setString(2,pass);
            statement.setInt(3, id);

            statement.executeUpdate();

            rs.close();
            stmt.close();
            response.sendRedirect("/db");
        } catch (Exception exc)  {
            out.println(exc.getMessage());
        } finally {
            try { con.close(); } catch (Exception exc) {}
        }
        out.close();
    }

    protected void doGet(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
        response.setContentType("text/html; charset=windows-1250");
        PrintWriter out = response.getWriter();
                Connection con = null;

        try {



            synchronized (dataSource) {
                con = dataSource.getConnection();
            }
            String idParam = request.getParameter("id");

            if (idParam == null ||  idParam == "")
            {
                out.println("Nie podano identyfikatora użytkownika do edycji ");
                return;
            }

            try
            {
                Integer.parseInt(idParam);
            }
            catch (NumberFormatException e)
            {
                out.println("Parametr ID powinien być liczbą całkowitą!");
                return;
            }

            Statement stmt = con.createStatement();

            ResultSet rs = stmt.executeQuery("select * from users WHERE user_id = "+ idParam);

            if (!rs.next()) {
                out.println("Nie znaleziono wskazanego użytkownika");
                return;
            }
            String name = rs.getString("user_name");
            String pass = rs.getString("user_password");


            out.println("<h2>Edytuj użytkownika </h2>");
            out.println("<form method=\"POST\">");
            out.println("<input type=\"hidden\" name=\"id\" value=\""+idParam+"\">");
            out.println("Nazwa: <br/><input type=\"text\" name=\"username\" value=\""+name +"\">");
            out.println("</br>");

            out.println("Hasło: <br/><input type=\"text\" name=\"password\" value=\""+pass+"\">");
            out.println("</br>");
            out.println("<input type=\"submit\" value=\"Zapisz\">");
            out.println("</form>");

            rs.close();
            stmt.close();
        } catch (Exception exc)  {
            out.println(exc.getMessage());
        } finally {
            try { con.close(); } catch (Exception exc) {}
        }
        out.close();
    }
}
