package protocol;

import pl.edu.s3996.zad2.InvalidMessageException;

public class AddResponseMessage extends BaseMessage {
    public final static String MessageType = "ADD_RESPONSE";

    public AddResponseMessage() {
        super(MessageType);
    }

    private int sum;

    public int getSum() {
        return sum;
    }

    public void setSum(int sum) {
        this.sum = sum;
    }

    @Override
    public String toString() {
        return "AddResponseMessage{" +
                "sum=" + sum +
                '}';
    }

    @Override
    public void parseFromString(String s) throws InvalidMessageException {
        super.parseFromString(s);

        if (!isValidMessage(s))
            throw new InvalidMessageException();

        super.parseFromString(s);

        String[] array = s.split(":");


        sum = Integer.parseInt(array[1]);
    }

    @Override
    public BaseMessage getResponse() {
        return null;
    }

    private boolean isValidMessage(String s) {
        String[] array = s.split(":");
        return array.length == 2 && array[0].equals(getMessageName());
    }


    @Override
    public String saveToString() {
        return getMessageName() + ":" + sum;
    }
}
