package protocol;

import pl.edu.s3996.zad2.InvalidMessageException;

/**
 * Created by Adam on 2014-06-02.
 */
public class EchoRequestMessage extends BaseMessage {

    public static final String MessageType = "ECHO_REQUEST";

    public EchoRequestMessage() {
        super(MessageType);
    }

    private String messageToReply;

    @Override
    public String toString() {
        return "EchoRequestMessage{" +
                "messageToReply='" + messageToReply + '\'' +
                '}';
    }

    public String getMessageToReply() {
        return messageToReply;
    }

    public void setMessageToReply(String messageToReply) {
        this.messageToReply = messageToReply;
    }

    @Override
    public void parseFromString(String s) throws InvalidMessageException {

        if (!isValidMessage(s))
            throw new InvalidMessageException();

        super.parseFromString(s);

        String[] array = s.split(":");
        messageToReply = array[1];
    }

    @Override
    public BaseMessage getResponse() {
        EchoResponseMessage message = new EchoResponseMessage();
        message.setMessageToReply(getMessageToReply());
        return message;
    }

    private boolean isValidMessage(String s) {
        String[] array = s.split(":");
        if (array.length != 2)
            return false;
        if (!array[0].equals(getMessageName()))
            return false;
        return true;
    }

    @Override
    public String saveToString() {
        return getMessageName() + ":" + messageToReply;
    }
}
