package protocol;


import pl.edu.s3996.zad2.InvalidMessageException;

public class EchoResponseMessage extends BaseMessage {

    public static final String MessageType = "ECHO_RESPONSE";

    public EchoResponseMessage() {
        super(MessageType);
    }

    private String messageToReply;

    public String getMessage() {
        return messageToReply;
    }


    @Override
    public String toString() {
        return "EchoResponseMessage{" +
                "messageToReply='" + messageToReply + '\'' +
                '}';
    }

    public void setMessageToReply(String messageToReply) {
        this.messageToReply = messageToReply;
    }

    @Override
    public void parseFromString(String s) throws InvalidMessageException {

        if (!isValidMessage(s))
            throw new InvalidMessageException();

        super.parseFromString(s);

        String[] array = s.split(":");
        messageToReply = array[1];
    }

    @Override
    public BaseMessage getResponse() {
        return null;
    }

    private boolean isValidMessage(String s) {
        String[] array = s.split(":");
        if (array.length != 2)
            return false;
        if (!array[0].equals(getMessageName()))
            return false;
        return true;
    }

    @Override
    public String saveToString() {
        return getMessageName() + ":" + messageToReply;
    }
}
