package pl.edu.pjwstk.s3996.zad10;


import javax.swing.*;
import java.awt.*;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

/**
 * Created by Adam on 2014-06-07.
 */
public class SampleGui  extends JFrame implements ActionListener {
    private static final long serialVersionUID = 465320630720463494L;

    private AdderStub sampleServiceStub;

    private JButton btnEchoMessage;

    private JTextField param1TextArea;
    private JTextField param2TextArea;
    private JTextField responseTextArea;


    public SampleGui() {
        try {
            this.sampleServiceStub = new AdderStub("http://localhost:9595/axis2/services/Adder");
        } catch (org.apache.axis2.AxisFault axisFault) {
            axisFault.printStackTrace();
        }

        this.btnEchoMessage = new JButton("Add");
        this.btnEchoMessage.addActionListener(this);

        JPanel panel = new JPanel();

        this.param1TextArea = new JTextField(10);
        this.param2TextArea = new JTextField(10);
        this.responseTextArea= new JTextField(10);
        this.responseTextArea.setEnabled(false);


        FlowLayout layout = new FlowLayout();
        panel.setLayout(layout);

        panel.add(this.param1TextArea);
        panel.add(this.param2TextArea);
        panel.add(this.btnEchoMessage);
        panel.add(this.responseTextArea);

        this.getContentPane().add(panel);


        final int DEFAULT_WIDTH = 500;
        final int DEFAULT_HEIGHT = 90;

        this.pack();
        this.setSize(DEFAULT_WIDTH, DEFAULT_HEIGHT);
        this.setVisible(true);
    }


    private void showMessageBox(Throwable ex) {
        JOptionPane.showMessageDialog(this, ex);
    }
//
    public void actionPerformed(ActionEvent e) {
        try
        {

            AdderStub.TimeoutAdd add = new AdderStub.TimeoutAdd();
            int param1, param2;
            try {
                param1 = Integer.parseInt(this.param1TextArea.getText());
                param2 = Integer.parseInt(this.param2TextArea.getText());
            }
            catch (NumberFormatException ex)
            {
                JOptionPane.showMessageDialog(this, "Proszę podać liczby!");
                return;
            }
            add.setParam1(param1);
            add.setParam2(param2);

            btnEchoMessage.setEnabled(false);
            sampleServiceStub.starttimeoutAdd(add, new ResponseHandler());
        } catch (Throwable ex) {
            this.showMessageBox(ex);
        }
    }

    private final class ResponseHandler extends AdderCallbackHandler
    {

        @Override
        public void receiveResulttimeoutAdd(AdderStub.TimeoutAddResponse result) {
            super.receiveResulttimeoutAdd(result);
            responseTextArea.setText("Wynik " + result.get_return());
            btnEchoMessage.setEnabled(true);
        }

        @Override
        public void receiveErrortimeoutAdd(Exception e) {
            showMessageBox(e);
            btnEchoMessage.setEnabled(true);
            super.receiveErrortimeoutAdd(e);
        }
    }
}
